/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>RFunction</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RFunction#getFunctionName <em>Function Name</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RFunction#getParameters <em>Parameters</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RFunction#getReturnValue <em>Return Value</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RFunction#getFunctionType <em>Function Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRFunction()
 * @model 
 * @generated
 */
public interface RFunction extends RObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * Returns the value of the '<em><b>Function Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Function Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Function Name</em>' attribute.
	 * @see #setFunctionName(RSymbol)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRFunction_FunctionName()
	 * @model dataType="com.example.rule.ecore.rulemetamodel.RSymbol"
	 * @generated
	 */
	RSymbol getFunctionName();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RFunction#getFunctionName <em>Function Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Function Name</em>' attribute.
	 * @see #getFunctionName()
	 * @generated
	 */
	void setFunctionName(RSymbol value);

	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' attribute list.
	 * The list contents are of type {@link com.example.rule.ecore.rulemetamodel.RDataType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameters</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameters</em>' attribute list.
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRFunction_Parameters()
	 * @model type="com.example.rule.ecore.rulemetamodel.RDataType" dataType="com.example.rule.ecore.rulemetamodel.RDataType"
	 * @generated
	 */
	EList getParameters();

	/**
	 * Returns the value of the '<em><b>Return Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Return Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Return Value</em>' attribute.
	 * @see #setReturnValue(RDataType)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRFunction_ReturnValue()
	 * @model dataType="com.example.rule.ecore.rulemetamodel.RDataType"
	 * @generated
	 */
	RDataType getReturnValue();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RFunction#getReturnValue <em>Return Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Return Value</em>' attribute.
	 * @see #getReturnValue()
	 * @generated
	 */
	void setReturnValue(RDataType value);

	/**
	 * Returns the value of the '<em><b>Function Type</b></em>' attribute.
	 * The literals are from the enumeration {@link com.example.rule.ecore.rulemetamodel.RFunctionType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Function Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Function Type</em>' attribute.
	 * @see com.example.rule.ecore.rulemetamodel.RFunctionType
	 * @see #setFunctionType(RFunctionType)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRFunction_FunctionType()
	 * @model 
	 * @generated
	 */
	RFunctionType getFunctionType();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RFunction#getFunctionType <em>Function Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Function Type</em>' attribute.
	 * @see com.example.rule.ecore.rulemetamodel.RFunctionType
	 * @see #getFunctionType()
	 * @generated
	 */
	void setFunctionType(RFunctionType value);

} // RFunction
