/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>RModule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RModule#getFactTemplates <em>Fact Templates</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RModule#getRules <em>Rules</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RModule#getRlists <em>Rlists</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RModule#getFunctions <em>Functions</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RModule#getOutputFilePath <em>Output File Path</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRModule()
 * @model 
 * @generated
 */
public interface RModule extends RObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * Returns the value of the '<em><b>Fact Templates</b></em>' containment reference list.
	 * The list contents are of type {@link com.example.rule.ecore.rulemetamodel.RFactTemplate}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Fact Templates</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Fact Templates</em>' containment reference list.
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRModule_FactTemplates()
	 * @model type="com.example.rule.ecore.rulemetamodel.RFactTemplate" containment="true"
	 * @generated
	 */
	EList getFactTemplates();

	/**
	 * Returns the value of the '<em><b>Rules</b></em>' containment reference list.
	 * The list contents are of type {@link com.example.rule.ecore.rulemetamodel.RRule}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rules</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rules</em>' containment reference list.
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRModule_Rules()
	 * @model type="com.example.rule.ecore.rulemetamodel.RRule" containment="true"
	 * @generated
	 */
	EList getRules();

	/**
	 * Returns the value of the '<em><b>Rlists</b></em>' containment reference list.
	 * The list contents are of type {@link com.example.rule.ecore.rulemetamodel.RList}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rlists</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rlists</em>' containment reference list.
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRModule_Rlists()
	 * @model type="com.example.rule.ecore.rulemetamodel.RList" containment="true"
	 * @generated
	 */
	EList getRlists();

	/**
	 * Returns the value of the '<em><b>Functions</b></em>' containment reference list.
	 * The list contents are of type {@link com.example.rule.ecore.rulemetamodel.RFunction}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Functions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Functions</em>' containment reference list.
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRModule_Functions()
	 * @model type="com.example.rule.ecore.rulemetamodel.RFunction" containment="true"
	 * @generated
	 */
	EList getFunctions();

	/**
	 * Returns the value of the '<em><b>Output File Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Output File Path</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Output File Path</em>' attribute.
	 * @see #setOutputFilePath(String)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRModule_OutputFilePath()
	 * @model 
	 * @generated
	 */
	String getOutputFilePath();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RModule#getOutputFilePath <em>Output File Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Output File Path</em>' attribute.
	 * @see #getOutputFilePath()
	 * @generated
	 */
	void setOutputFilePath(String value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model 
	 * @generated
	 */
	void generate();

} // RModule
