/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel;


import java.util.ArrayList;

public class RMultiField extends RDataType {


	public RMultiField() {
		super();
	}
	
	public RMultiField(String initValue) {
		super();
		fromString(initValue);
	}
	
	public RDataType valueOf(String value)
	{
		return new RMultiField();
	}
	
	ArrayList fieldList = new ArrayList();

	private void fromString(String value)
	{
		if (value.startsWith("("))
			value = value.substring(1);
		
		if (value.endsWith(")"))
			value = value.substring(0, value.length() - 1);
		
		String[] fields = value.split("[\u0020\t]+");
		fieldList.clear();
		for (int i = 0; i < fields.length; i++)
		{
			// ToDo: should convert string to DataType.
			fieldList.add(fields[i]);
		}
	}
	
	public String toString()
	{
		String result = fieldList.toString().replaceAll(", ", " ");
		result = result.substring(1, result.length() - 1);
		return "(" + result + ")";
	}
} 