/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>RRule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RRule#getSalience <em>Salience</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RRule#getCondition <em>Condition</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RRule#getRuleName <em>Rule Name</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RRule#getActions <em>Actions</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RRule#getRuleType <em>Rule Type</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RRule#getCeMatchPattern <em>Ce Match Pattern</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.RRule#getDescription <em>Description</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule()
 * @model 
 * @generated
 */
public interface RRule extends RObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * Returns the value of the '<em><b>Salience</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Salience</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Salience</em>' attribute.
	 * @see #setSalience(int)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule_Salience()
	 * @model 
	 * @generated
	 */
	int getSalience();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RRule#getSalience <em>Salience</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Salience</em>' attribute.
	 * @see #getSalience()
	 * @generated
	 */
	void setSalience(int value);

	/**
	 * Returns the value of the '<em><b>Condition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Condition</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Condition</em>' containment reference.
	 * @see #setCondition(RCondElem)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule_Condition()
	 * @model containment="true"
	 * @generated
	 */
	RCondElem getCondition();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RRule#getCondition <em>Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Condition</em>' containment reference.
	 * @see #getCondition()
	 * @generated
	 */
	void setCondition(RCondElem value);

	/**
	 * Returns the value of the '<em><b>Rule Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rule Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rule Name</em>' attribute.
	 * @see #setRuleName(RSymbol)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule_RuleName()
	 * @model dataType="com.example.rule.ecore.rulemetamodel.RSymbol"
	 * @generated
	 */
	RSymbol getRuleName();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RRule#getRuleName <em>Rule Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rule Name</em>' attribute.
	 * @see #getRuleName()
	 * @generated
	 */
	void setRuleName(RSymbol value);

	/**
	 * Returns the value of the '<em><b>Actions</b></em>' reference list.
	 * The list contents are of type {@link com.example.rule.ecore.rulemetamodel.RFunction}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actions</em>' reference list.
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule_Actions()
	 * @model type="com.example.rule.ecore.rulemetamodel.RFunction"
	 * @generated
	 */
	EList getActions();

	/**
	 * Returns the value of the '<em><b>Rule Type</b></em>' attribute.
	 * The literals are from the enumeration {@link com.example.rule.ecore.rulemetamodel.RRuleType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rule Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rule Type</em>' attribute.
	 * @see com.example.rule.ecore.rulemetamodel.RRuleType
	 * @see #setRuleType(RRuleType)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule_RuleType()
	 * @model 
	 * @generated
	 */
	RRuleType getRuleType();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RRule#getRuleType <em>Rule Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rule Type</em>' attribute.
	 * @see com.example.rule.ecore.rulemetamodel.RRuleType
	 * @see #getRuleType()
	 * @generated
	 */
	void setRuleType(RRuleType value);

	/**
	 * Returns the value of the '<em><b>Ce Match Pattern</b></em>' containment reference list.
	 * The list contents are of type {@link com.example.rule.ecore.rulemetamodel.RPattern}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ce Match Pattern</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ce Match Pattern</em>' containment reference list.
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule_CeMatchPattern()
	 * @model type="com.example.rule.ecore.rulemetamodel.RPattern" containment="true"
	 * @generated
	 */
	EList getCeMatchPattern();

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRule_Description()
	 * @model 
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link com.example.rule.ecore.rulemetamodel.RRule#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

} // RRule
