/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>RRule Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage#getRRuleType()
 * @model
 * @generated
 */
public final class RRuleType extends AbstractEnumerator {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The '<em><b>Constraint</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CONSTRAINT_LITERAL
	 * @model name="constraint"
	 * @generated
	 * @ordered
	 */
	public static final int CONSTRAINT = 0;

	/**
	 * The '<em><b>Initialization</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INITIALIZATION_LITERAL
	 * @model name="initialization"
	 * @generated
	 * @ordered
	 */
	public static final int INITIALIZATION = 1;

	/**
	 * The '<em><b>Constraint</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Constraint</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CONSTRAINT
	 * @generated
	 * @ordered
	 */
	public static final RRuleType CONSTRAINT_LITERAL = new RRuleType(CONSTRAINT, "constraint");

	/**
	 * The '<em><b>Initialization</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Initialization</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INITIALIZATION
	 * @generated
	 * @ordered
	 */
	public static final RRuleType INITIALIZATION_LITERAL = new RRuleType(INITIALIZATION, "initialization");

	/**
	 * An array of all the '<em><b>RRule Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RRuleType[] VALUES_ARRAY =
		new RRuleType[] {
			CONSTRAINT_LITERAL,
			INITIALIZATION_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>RRule Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>RRule Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RRuleType get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RRuleType result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>RRule Type</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RRuleType get(int value) {
		switch (value) {
			case CONSTRAINT: return CONSTRAINT_LITERAL;
			case INITIALIZATION: return INITIALIZATION_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RRuleType(int value, String name) {
		super(value, name);
	}

} //RRuleType
