/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel;

public class RSymbol extends RDataType implements Comparable {

	public boolean equals(Object o) {
		if (this == o)
			return true;
		else if (o == null || !(o instanceof RSymbol))
			return false;
		else {
			RSymbol obj = (RSymbol) o;
			if (symbol == null)
				return (obj.symbol == null);
			else
				return symbol.equals(obj.symbol);
		}
	}
	
	public int hashCode() {
		return (symbol != null ? symbol.hashCode() : 0);
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object o) {
		
		if (!(o instanceof RSymbol))
			return -1;
		
		RSymbol obj = (RSymbol) o;
		return symbol.compareTo(obj.toListString());
	}
	
	public RSymbol() {
		super();
	}
	
	public RSymbol(String initValue) {
		super();
		symbol = initValue;
	}
	
	private String symbol = "";
	
	public String toString()
	{
		return symbol;
	}
	
	public String toListString()
	{
		return symbol;
	}
} 