/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelFactory
 * @generated
 */
public interface RulemetamodelPackage extends EPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "rulemetamodel";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.example.com/rule/2004/RuleMetaModel";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "rulemetamodel";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RulemetamodelPackage eINSTANCE = com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RObjectImpl <em>RObject</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RObjectImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRObject()
	 * @generated
	 */
	int ROBJECT = 8;

	/**
	 * The number of structural features of the the '<em>RObject</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROBJECT_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RListImpl <em>RList</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RListImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRList()
	 * @generated
	 */
	int RLIST = 0;

	/**
	 * The feature id for the '<em><b>List Elements</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RLIST__LIST_ELEMENTS = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>RList</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RLIST_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RFactTemplateImpl <em>RFact Template</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RFactTemplateImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRFactTemplate()
	 * @generated
	 */
	int RFACT_TEMPLATE = 1;

	/**
	 * The feature id for the '<em><b>Slot</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT_TEMPLATE__SLOT = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Fact Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT_TEMPLATE__FACT_NAME = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>RFact Template</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT_TEMPLATE_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl <em>RRule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RRuleImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRRule()
	 * @generated
	 */
	int RRULE = 2;

	/**
	 * The feature id for the '<em><b>Salience</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE__SALIENCE = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE__CONDITION = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Rule Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE__RULE_NAME = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Actions</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE__ACTIONS = ROBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Rule Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE__RULE_TYPE = ROBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Ce Match Pattern</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE__CE_MATCH_PATTERN = ROBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE__DESCRIPTION = ROBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the the '<em>RRule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RRULE_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 7;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RFactSlotImpl <em>RFact Slot</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RFactSlotImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRFactSlot()
	 * @generated
	 */
	int RFACT_SLOT = 3;

	/**
	 * The feature id for the '<em><b>Slot Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT_SLOT__SLOT_NAME = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Slot Value Range</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT_SLOT__SLOT_VALUE_RANGE = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>RFact Slot</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT_SLOT_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RPatternImpl <em>RPattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RPatternImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRPattern()
	 * @generated
	 */
	int RPATTERN = 4;

	/**
	 * The feature id for the '<em><b>Fact Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPATTERN__FACT_TEMPLATE = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Slot Match Exp</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPATTERN__SLOT_MATCH_EXP = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>RPattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RPATTERN_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RSlotMatchExpImpl <em>RSlot Match Exp</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RSlotMatchExpImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRSlotMatchExp()
	 * @generated
	 */
	int RSLOT_MATCH_EXP = 5;

	/**
	 * The feature id for the '<em><b>Fact Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSLOT_MATCH_EXP__FACT_TEMPLATE = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Slot Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSLOT_MATCH_EXP__SLOT_NAME = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Match Exp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSLOT_MATCH_EXP__MATCH_EXP = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the the '<em>RSlot Match Exp</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSLOT_MATCH_EXP_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RCondElemImpl <em>RCond Elem</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RCondElemImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRCondElem()
	 * @generated
	 */
	int RCOND_ELEM = 6;

	/**
	 * The feature id for the '<em><b>Ce Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RCOND_ELEM__CE_NAME = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Ce Match Pattern</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RCOND_ELEM__CE_MATCH_PATTERN = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Child CE</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RCOND_ELEM__CHILD_CE = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the the '<em>RCond Elem</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RCOND_ELEM_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RModuleImpl <em>RModule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RModuleImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRModule()
	 * @generated
	 */
	int RMODULE = 7;

	/**
	 * The feature id for the '<em><b>Fact Templates</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RMODULE__FACT_TEMPLATES = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RMODULE__RULES = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Rlists</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RMODULE__RLISTS = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RMODULE__FUNCTIONS = ROBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Output File Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RMODULE__OUTPUT_FILE_PATH = ROBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the the '<em>RModule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RMODULE_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RFunctionImpl <em>RFunction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RFunctionImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRFunction()
	 * @generated
	 */
	int RFUNCTION = 9;

	/**
	 * The feature id for the '<em><b>Function Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFUNCTION__FUNCTION_NAME = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFUNCTION__PARAMETERS = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Return Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFUNCTION__RETURN_VALUE = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Function Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFUNCTION__FUNCTION_TYPE = ROBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the the '<em>RFunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFUNCTION_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RFactImpl <em>RFact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RFactImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRFact()
	 * @generated
	 */
	int RFACT = 10;

	/**
	 * The feature id for the '<em><b>Fact Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT__FACT_TEMPLATE = ROBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Slots</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT__SLOTS = ROBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>RFact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RFACT_FEATURE_COUNT = ROBJECT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.impl.RSymbolToDataTypeMapEntryImpl <em>RSymbol To Data Type Map Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.impl.RSymbolToDataTypeMapEntryImpl
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRSymbolToDataTypeMapEntry()
	 * @generated
	 */
	int RSYMBOL_TO_DATA_TYPE_MAP_ENTRY = 11;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSYMBOL_TO_DATA_TYPE_MAP_ENTRY__KEY = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSYMBOL_TO_DATA_TYPE_MAP_ENTRY__VALUE = 1;

	/**
	 * The number of structural features of the the '<em>RSymbol To Data Type Map Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RSYMBOL_TO_DATA_TYPE_MAP_ENTRY_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.RCondElemEnum <em>RCond Elem Enum</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RCondElemEnum
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRCondElemEnum()
	 * @generated
	 */
	int RCOND_ELEM_ENUM = 12;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.RRuleType <em>RRule Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RRuleType
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRRuleType()
	 * @generated
	 */
	int RRULE_TYPE = 13;

	/**
	 * The meta object id for the '{@link com.example.rule.ecore.rulemetamodel.RFunctionType <em>RFunction Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RFunctionType
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRFunctionType()
	 * @generated
	 */
	int RFUNCTION_TYPE = 14;

	/**
	 * The meta object id for the '<em>RSymbol</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RSymbol
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRSymbol()
	 * @generated
	 */
	int RSYMBOL = 15;

	/**
	 * The meta object id for the '<em>RFact Address</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RFactAddress
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRFactAddress()
	 * @generated
	 */
	int RFACT_ADDRESS = 16;

	/**
	 * The meta object id for the '<em>RInteger</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RInteger
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRInteger()
	 * @generated
	 */
	int RINTEGER = 17;

	/**
	 * The meta object id for the '<em>RFloat</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RFloat
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRFloat()
	 * @generated
	 */
	int RFLOAT = 18;

	/**
	 * The meta object id for the '<em>RData Type</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RDataType
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRDataType()
	 * @generated
	 */
	int RDATA_TYPE = 19;

	/**
	 * The meta object id for the '<em>RMulti Field</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.example.rule.ecore.rulemetamodel.RMultiField
	 * @see com.example.rule.ecore.rulemetamodel.impl.RulemetamodelPackageImpl#getRMultiField()
	 * @generated
	 */
	int RMULTI_FIELD = 20;


	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RList <em>RList</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RList</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RList
	 * @generated
	 */
	EClass getRList();

	/**
	 * Returns the meta object for the attribute list '{@link com.example.rule.ecore.rulemetamodel.RList#getListElements <em>List Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>List Elements</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RList#getListElements()
	 * @see #getRList()
	 * @generated
	 */
	EAttribute getRList_ListElements();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RFactTemplate <em>RFact Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RFact Template</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFactTemplate
	 * @generated
	 */
	EClass getRFactTemplate();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RFactTemplate#getSlot <em>Slot</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Slot</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFactTemplate#getSlot()
	 * @see #getRFactTemplate()
	 * @generated
	 */
	EReference getRFactTemplate_Slot();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RFactTemplate#getFactName <em>Fact Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Fact Name</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFactTemplate#getFactName()
	 * @see #getRFactTemplate()
	 * @generated
	 */
	EAttribute getRFactTemplate_FactName();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RRule <em>RRule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RRule</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule
	 * @generated
	 */
	EClass getRRule();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RRule#getSalience <em>Salience</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Salience</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule#getSalience()
	 * @see #getRRule()
	 * @generated
	 */
	EAttribute getRRule_Salience();

	/**
	 * Returns the meta object for the containment reference '{@link com.example.rule.ecore.rulemetamodel.RRule#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Condition</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule#getCondition()
	 * @see #getRRule()
	 * @generated
	 */
	EReference getRRule_Condition();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RRule#getRuleName <em>Rule Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rule Name</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule#getRuleName()
	 * @see #getRRule()
	 * @generated
	 */
	EAttribute getRRule_RuleName();

	/**
	 * Returns the meta object for the reference list '{@link com.example.rule.ecore.rulemetamodel.RRule#getActions <em>Actions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Actions</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule#getActions()
	 * @see #getRRule()
	 * @generated
	 */
	EReference getRRule_Actions();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RRule#getRuleType <em>Rule Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rule Type</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule#getRuleType()
	 * @see #getRRule()
	 * @generated
	 */
	EAttribute getRRule_RuleType();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RRule#getCeMatchPattern <em>Ce Match Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ce Match Pattern</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule#getCeMatchPattern()
	 * @see #getRRule()
	 * @generated
	 */
	EReference getRRule_CeMatchPattern();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RRule#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRule#getDescription()
	 * @see #getRRule()
	 * @generated
	 */
	EAttribute getRRule_Description();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RFactSlot <em>RFact Slot</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RFact Slot</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFactSlot
	 * @generated
	 */
	EClass getRFactSlot();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RFactSlot#getSlotName <em>Slot Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Slot Name</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFactSlot#getSlotName()
	 * @see #getRFactSlot()
	 * @generated
	 */
	EAttribute getRFactSlot_SlotName();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RFactSlot#getSlotValueRange <em>Slot Value Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Slot Value Range</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFactSlot#getSlotValueRange()
	 * @see #getRFactSlot()
	 * @generated
	 */
	EAttribute getRFactSlot_SlotValueRange();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RPattern <em>RPattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RPattern</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RPattern
	 * @generated
	 */
	EClass getRPattern();

	/**
	 * Returns the meta object for the reference '{@link com.example.rule.ecore.rulemetamodel.RPattern#getFactTemplate <em>Fact Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Fact Template</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RPattern#getFactTemplate()
	 * @see #getRPattern()
	 * @generated
	 */
	EReference getRPattern_FactTemplate();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RPattern#getSlotMatchExp <em>Slot Match Exp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Slot Match Exp</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RPattern#getSlotMatchExp()
	 * @see #getRPattern()
	 * @generated
	 */
	EReference getRPattern_SlotMatchExp();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RSlotMatchExp <em>RSlot Match Exp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RSlot Match Exp</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RSlotMatchExp
	 * @generated
	 */
	EClass getRSlotMatchExp();

	/**
	 * Returns the meta object for the reference '{@link com.example.rule.ecore.rulemetamodel.RSlotMatchExp#getFactTemplate <em>Fact Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Fact Template</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RSlotMatchExp#getFactTemplate()
	 * @see #getRSlotMatchExp()
	 * @generated
	 */
	EReference getRSlotMatchExp_FactTemplate();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RSlotMatchExp#getSlotName <em>Slot Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Slot Name</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RSlotMatchExp#getSlotName()
	 * @see #getRSlotMatchExp()
	 * @generated
	 */
	EAttribute getRSlotMatchExp_SlotName();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RSlotMatchExp#getMatchExp <em>Match Exp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Match Exp</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RSlotMatchExp#getMatchExp()
	 * @see #getRSlotMatchExp()
	 * @generated
	 */
	EAttribute getRSlotMatchExp_MatchExp();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RCondElem <em>RCond Elem</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RCond Elem</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RCondElem
	 * @generated
	 */
	EClass getRCondElem();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RCondElem#getCeName <em>Ce Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ce Name</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RCondElem#getCeName()
	 * @see #getRCondElem()
	 * @generated
	 */
	EAttribute getRCondElem_CeName();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RCondElem#getCeMatchPattern <em>Ce Match Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ce Match Pattern</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RCondElem#getCeMatchPattern()
	 * @see #getRCondElem()
	 * @generated
	 */
	EReference getRCondElem_CeMatchPattern();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RCondElem#getChildCE <em>Child CE</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Child CE</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RCondElem#getChildCE()
	 * @see #getRCondElem()
	 * @generated
	 */
	EReference getRCondElem_ChildCE();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RModule <em>RModule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RModule</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RModule
	 * @generated
	 */
	EClass getRModule();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RModule#getFactTemplates <em>Fact Templates</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Fact Templates</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RModule#getFactTemplates()
	 * @see #getRModule()
	 * @generated
	 */
	EReference getRModule_FactTemplates();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RModule#getRules <em>Rules</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rules</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RModule#getRules()
	 * @see #getRModule()
	 * @generated
	 */
	EReference getRModule_Rules();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RModule#getRlists <em>Rlists</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rlists</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RModule#getRlists()
	 * @see #getRModule()
	 * @generated
	 */
	EReference getRModule_Rlists();

	/**
	 * Returns the meta object for the containment reference list '{@link com.example.rule.ecore.rulemetamodel.RModule#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RModule#getFunctions()
	 * @see #getRModule()
	 * @generated
	 */
	EReference getRModule_Functions();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RModule#getOutputFilePath <em>Output File Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Output File Path</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RModule#getOutputFilePath()
	 * @see #getRModule()
	 * @generated
	 */
	EAttribute getRModule_OutputFilePath();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RObject <em>RObject</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RObject</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RObject
	 * @generated
	 */
	EClass getRObject();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RFunction <em>RFunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RFunction</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFunction
	 * @generated
	 */
	EClass getRFunction();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RFunction#getFunctionName <em>Function Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Function Name</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFunction#getFunctionName()
	 * @see #getRFunction()
	 * @generated
	 */
	EAttribute getRFunction_FunctionName();

	/**
	 * Returns the meta object for the attribute list '{@link com.example.rule.ecore.rulemetamodel.RFunction#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Parameters</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFunction#getParameters()
	 * @see #getRFunction()
	 * @generated
	 */
	EAttribute getRFunction_Parameters();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RFunction#getReturnValue <em>Return Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Return Value</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFunction#getReturnValue()
	 * @see #getRFunction()
	 * @generated
	 */
	EAttribute getRFunction_ReturnValue();

	/**
	 * Returns the meta object for the attribute '{@link com.example.rule.ecore.rulemetamodel.RFunction#getFunctionType <em>Function Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Function Type</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFunction#getFunctionType()
	 * @see #getRFunction()
	 * @generated
	 */
	EAttribute getRFunction_FunctionType();

	/**
	 * Returns the meta object for class '{@link com.example.rule.ecore.rulemetamodel.RFact <em>RFact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RFact</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFact
	 * @generated
	 */
	EClass getRFact();

	/**
	 * Returns the meta object for the reference '{@link com.example.rule.ecore.rulemetamodel.RFact#getFactTemplate <em>Fact Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Fact Template</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFact#getFactTemplate()
	 * @see #getRFact()
	 * @generated
	 */
	EReference getRFact_FactTemplate();

	/**
	 * Returns the meta object for the reference list '{@link com.example.rule.ecore.rulemetamodel.RFact#getSlots <em>Slots</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Slots</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFact#getSlots()
	 * @see #getRFact()
	 * @generated
	 */
	EReference getRFact_Slots();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>RSymbol To Data Type Map Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>RSymbol To Data Type Map Entry</em>'.
	 * @see java.util.Map.Entry
	 * @model keyType="com.example.rule.ecore.rulemetamodel.RSymbol" keyDataType="com.example.rule.ecore.rulemetamodel.RSymbol" valueType="com.example.rule.ecore.rulemetamodel.RDataType" valueDataType="com.example.rule.ecore.rulemetamodel.RDataType" 
	 * @generated
	 */
	EClass getRSymbolToDataTypeMapEntry();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see java.util.Map.Entry
	 * @see #getRSymbolToDataTypeMapEntry()
	 * @generated
	 */
	EAttribute getRSymbolToDataTypeMapEntry_Key();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getRSymbolToDataTypeMapEntry()
	 * @generated
	 */
	EAttribute getRSymbolToDataTypeMapEntry_Value();

	/**
	 * Returns the meta object for enum '{@link com.example.rule.ecore.rulemetamodel.RCondElemEnum <em>RCond Elem Enum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>RCond Elem Enum</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RCondElemEnum
	 * @generated
	 */
	EEnum getRCondElemEnum();

	/**
	 * Returns the meta object for enum '{@link com.example.rule.ecore.rulemetamodel.RRuleType <em>RRule Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>RRule Type</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RRuleType
	 * @generated
	 */
	EEnum getRRuleType();

	/**
	 * Returns the meta object for enum '{@link com.example.rule.ecore.rulemetamodel.RFunctionType <em>RFunction Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>RFunction Type</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFunctionType
	 * @generated
	 */
	EEnum getRFunctionType();

	/**
	 * Returns the meta object for data type '{@link com.example.rule.ecore.rulemetamodel.RSymbol <em>RSymbol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>RSymbol</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RSymbol
	 * @model instanceClass="com.example.rule.ecore.rulemetamodel.RSymbol"
	 * @generated
	 */
	EDataType getRSymbol();

	/**
	 * Returns the meta object for data type '{@link com.example.rule.ecore.rulemetamodel.RFactAddress <em>RFact Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>RFact Address</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFactAddress
	 * @model instanceClass="com.example.rule.ecore.rulemetamodel.RFactAddress"
	 * @generated
	 */
	EDataType getRFactAddress();

	/**
	 * Returns the meta object for data type '{@link com.example.rule.ecore.rulemetamodel.RInteger <em>RInteger</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>RInteger</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RInteger
	 * @model instanceClass="com.example.rule.ecore.rulemetamodel.RInteger"
	 * @generated
	 */
	EDataType getRInteger();

	/**
	 * Returns the meta object for data type '{@link com.example.rule.ecore.rulemetamodel.RFloat <em>RFloat</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>RFloat</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RFloat
	 * @model instanceClass="com.example.rule.ecore.rulemetamodel.RFloat"
	 * @generated
	 */
	EDataType getRFloat();

	/**
	 * Returns the meta object for data type '{@link com.example.rule.ecore.rulemetamodel.RDataType <em>RData Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>RData Type</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RDataType
	 * @model instanceClass="com.example.rule.ecore.rulemetamodel.RDataType"
	 * @generated
	 */
	EDataType getRDataType();

	/**
	 * Returns the meta object for data type '{@link com.example.rule.ecore.rulemetamodel.RMultiField <em>RMulti Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>RMulti Field</em>'.
	 * @see com.example.rule.ecore.rulemetamodel.RMultiField
	 * @model instanceClass="com.example.rule.ecore.rulemetamodel.RMultiField"
	 * @generated
	 */
	EDataType getRMultiField();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	RulemetamodelFactory getRulemetamodelFactory();

} //RulemetamodelPackage
