/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.impl;

import com.example.rule.ecore.rulemetamodel.RCondElem;
import com.example.rule.ecore.rulemetamodel.RCondElemEnum;
import com.example.rule.ecore.rulemetamodel.RPattern;
import com.example.rule.ecore.rulemetamodel.RulemetamodelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>RCond Elem</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RCondElemImpl#getCeName <em>Ce Name</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RCondElemImpl#getCeMatchPattern <em>Ce Match Pattern</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RCondElemImpl#getChildCE <em>Child CE</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RCondElemImpl extends RObjectImpl implements RCondElem {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The default value of the '{@link #getCeName() <em>Ce Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCeName()
	 * @generated
	 * @ordered
	 */
	protected static final RCondElemEnum CE_NAME_EDEFAULT = RCondElemEnum.NOT_LITERAL;

	/**
	 * The cached value of the '{@link #getCeName() <em>Ce Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCeName()
	 * @generated
	 * @ordered
	 */
	protected RCondElemEnum ceName = CE_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCeMatchPattern() <em>Ce Match Pattern</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCeMatchPattern()
	 * @generated
	 * @ordered
	 */
	protected EList ceMatchPattern = null;

	/**
	 * The cached value of the '{@link #getChildCE() <em>Child CE</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getChildCE()
	 * @generated
	 * @ordered
	 */
	protected EList childCE = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RCondElemImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return RulemetamodelPackage.eINSTANCE.getRCondElem();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RCondElemEnum getCeName() {
		return ceName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCeName(RCondElemEnum newCeName) {
		RCondElemEnum oldCeName = ceName;
		ceName = newCeName == null ? CE_NAME_EDEFAULT : newCeName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RCOND_ELEM__CE_NAME, oldCeName, ceName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getCeMatchPattern() {
		if (ceMatchPattern == null) {
			ceMatchPattern = new EObjectContainmentEList(RPattern.class, this, RulemetamodelPackage.RCOND_ELEM__CE_MATCH_PATTERN);
		}
		return ceMatchPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getChildCE() {
		if (childCE == null) {
			childCE = new EObjectContainmentEList(RCondElem.class, this, RulemetamodelPackage.RCOND_ELEM__CHILD_CE);
		}
		return childCE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case RulemetamodelPackage.RCOND_ELEM__CE_MATCH_PATTERN:
					return ((InternalEList)getCeMatchPattern()).basicRemove(otherEnd, msgs);
				case RulemetamodelPackage.RCOND_ELEM__CHILD_CE:
					return ((InternalEList)getChildCE()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RCOND_ELEM__CE_NAME:
				return getCeName();
			case RulemetamodelPackage.RCOND_ELEM__CE_MATCH_PATTERN:
				return getCeMatchPattern();
			case RulemetamodelPackage.RCOND_ELEM__CHILD_CE:
				return getChildCE();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RCOND_ELEM__CE_NAME:
				setCeName((RCondElemEnum)newValue);
				return;
			case RulemetamodelPackage.RCOND_ELEM__CE_MATCH_PATTERN:
				getCeMatchPattern().clear();
				getCeMatchPattern().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RCOND_ELEM__CHILD_CE:
				getChildCE().clear();
				getChildCE().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RCOND_ELEM__CE_NAME:
				setCeName(CE_NAME_EDEFAULT);
				return;
			case RulemetamodelPackage.RCOND_ELEM__CE_MATCH_PATTERN:
				getCeMatchPattern().clear();
				return;
			case RulemetamodelPackage.RCOND_ELEM__CHILD_CE:
				getChildCE().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RCOND_ELEM__CE_NAME:
				return ceName != CE_NAME_EDEFAULT;
			case RulemetamodelPackage.RCOND_ELEM__CE_MATCH_PATTERN:
				return ceMatchPattern != null && !ceMatchPattern.isEmpty();
			case RulemetamodelPackage.RCOND_ELEM__CHILD_CE:
				return childCE != null && !childCE.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (ceName: ");
		result.append(ceName);
		result.append(')');
		return result.toString();
	}

} //RCondElemImpl
