/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.impl;

import com.example.rule.ecore.rulemetamodel.RDataType;
import com.example.rule.ecore.rulemetamodel.RFunction;
import com.example.rule.ecore.rulemetamodel.RFunctionType;
import com.example.rule.ecore.rulemetamodel.RSymbol;
import com.example.rule.ecore.rulemetamodel.RulemetamodelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>RFunction</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RFunctionImpl#getFunctionName <em>Function Name</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RFunctionImpl#getParameters <em>Parameters</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RFunctionImpl#getReturnValue <em>Return Value</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RFunctionImpl#getFunctionType <em>Function Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RFunctionImpl extends RObjectImpl implements RFunction {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The default value of the '{@link #getFunctionName() <em>Function Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctionName()
	 * @generated
	 * @ordered
	 */
	protected static final RSymbol FUNCTION_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getFunctionName() <em>Function Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctionName()
	 * @generated
	 * @ordered
	 */
	protected RSymbol functionName = FUNCTION_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getParameters() <em>Parameters</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameters()
	 * @generated
	 * @ordered
	 */
	protected EList parameters = null;

	/**
	 * The default value of the '{@link #getReturnValue() <em>Return Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReturnValue()
	 * @generated
	 * @ordered
	 */
	protected static final RDataType RETURN_VALUE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getReturnValue() <em>Return Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReturnValue()
	 * @generated
	 * @ordered
	 */
	protected RDataType returnValue = RETURN_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getFunctionType() <em>Function Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctionType()
	 * @generated
	 * @ordered
	 */
	protected static final RFunctionType FUNCTION_TYPE_EDEFAULT = RFunctionType.SYSTEM_LITERAL;

	/**
	 * The cached value of the '{@link #getFunctionType() <em>Function Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctionType()
	 * @generated
	 * @ordered
	 */
	protected RFunctionType functionType = FUNCTION_TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RFunctionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return RulemetamodelPackage.eINSTANCE.getRFunction();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RSymbol getFunctionName() {
		return functionName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFunctionName(RSymbol newFunctionName) {
		RSymbol oldFunctionName = functionName;
		functionName = newFunctionName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RFUNCTION__FUNCTION_NAME, oldFunctionName, functionName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getParameters() {
		if (parameters == null) {
			parameters = new EDataTypeUniqueEList(RDataType.class, this, RulemetamodelPackage.RFUNCTION__PARAMETERS);
		}
		return parameters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RDataType getReturnValue() {
		return returnValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReturnValue(RDataType newReturnValue) {
		RDataType oldReturnValue = returnValue;
		returnValue = newReturnValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RFUNCTION__RETURN_VALUE, oldReturnValue, returnValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RFunctionType getFunctionType() {
		return functionType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFunctionType(RFunctionType newFunctionType) {
		RFunctionType oldFunctionType = functionType;
		functionType = newFunctionType == null ? FUNCTION_TYPE_EDEFAULT : newFunctionType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RFUNCTION__FUNCTION_TYPE, oldFunctionType, functionType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RFUNCTION__FUNCTION_NAME:
				return getFunctionName();
			case RulemetamodelPackage.RFUNCTION__PARAMETERS:
				return getParameters();
			case RulemetamodelPackage.RFUNCTION__RETURN_VALUE:
				return getReturnValue();
			case RulemetamodelPackage.RFUNCTION__FUNCTION_TYPE:
				return getFunctionType();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RFUNCTION__FUNCTION_NAME:
				setFunctionName((RSymbol)newValue);
				return;
			case RulemetamodelPackage.RFUNCTION__PARAMETERS:
				getParameters().clear();
				getParameters().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RFUNCTION__RETURN_VALUE:
				setReturnValue((RDataType)newValue);
				return;
			case RulemetamodelPackage.RFUNCTION__FUNCTION_TYPE:
				setFunctionType((RFunctionType)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RFUNCTION__FUNCTION_NAME:
				setFunctionName(FUNCTION_NAME_EDEFAULT);
				return;
			case RulemetamodelPackage.RFUNCTION__PARAMETERS:
				getParameters().clear();
				return;
			case RulemetamodelPackage.RFUNCTION__RETURN_VALUE:
				setReturnValue(RETURN_VALUE_EDEFAULT);
				return;
			case RulemetamodelPackage.RFUNCTION__FUNCTION_TYPE:
				setFunctionType(FUNCTION_TYPE_EDEFAULT);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RFUNCTION__FUNCTION_NAME:
				return FUNCTION_NAME_EDEFAULT == null ? functionName != null : !FUNCTION_NAME_EDEFAULT.equals(functionName);
			case RulemetamodelPackage.RFUNCTION__PARAMETERS:
				return parameters != null && !parameters.isEmpty();
			case RulemetamodelPackage.RFUNCTION__RETURN_VALUE:
				return RETURN_VALUE_EDEFAULT == null ? returnValue != null : !RETURN_VALUE_EDEFAULT.equals(returnValue);
			case RulemetamodelPackage.RFUNCTION__FUNCTION_TYPE:
				return functionType != FUNCTION_TYPE_EDEFAULT;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (functionName: ");
		result.append(functionName);
		result.append(", parameters: ");
		result.append(parameters);
		result.append(", returnValue: ");
		result.append(returnValue);
		result.append(", functionType: ");
		result.append(functionType);
		result.append(')');
		return result.toString();
	}

} //RFunctionImpl
