/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.impl;

import com.example.rule.ecore.rulemetamodel.RFactTemplate;
import com.example.rule.ecore.rulemetamodel.RFunction;
import com.example.rule.ecore.rulemetamodel.RList;
import com.example.rule.ecore.rulemetamodel.RModule;
import com.example.rule.ecore.rulemetamodel.RRule;
import com.example.rule.ecore.rulemetamodel.RulemetamodelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import java.io.FileWriter;
import java.io.IOException;
import com.example.rule.ecore.templates.Module;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>RModule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RModuleImpl#getFactTemplates <em>Fact Templates</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RModuleImpl#getRules <em>Rules</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RModuleImpl#getRlists <em>Rlists</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RModuleImpl#getFunctions <em>Functions</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RModuleImpl#getOutputFilePath <em>Output File Path</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RModuleImpl extends RObjectImpl implements RModule {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The cached value of the '{@link #getFactTemplates() <em>Fact Templates</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactTemplates()
	 * @generated
	 * @ordered
	 */
	protected EList factTemplates = null;

	/**
	 * The cached value of the '{@link #getRules() <em>Rules</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRules()
	 * @generated
	 * @ordered
	 */
	protected EList rules = null;

	/**
	 * The cached value of the '{@link #getRlists() <em>Rlists</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRlists()
	 * @generated
	 * @ordered
	 */
	protected EList rlists = null;

	/**
	 * The cached value of the '{@link #getFunctions() <em>Functions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctions()
	 * @generated
	 * @ordered
	 */
	protected EList functions = null;

	/**
	 * The default value of the '{@link #getOutputFilePath() <em>Output File Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutputFilePath()
	 * @generated
	 * @ordered
	 */
	protected static final String OUTPUT_FILE_PATH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOutputFilePath() <em>Output File Path</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutputFilePath()
	 * @generated
	 * @ordered
	 */
	protected String outputFilePath = OUTPUT_FILE_PATH_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RModuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return RulemetamodelPackage.eINSTANCE.getRModule();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getFactTemplates() {
		if (factTemplates == null) {
			factTemplates = new EObjectContainmentEList(RFactTemplate.class, this, RulemetamodelPackage.RMODULE__FACT_TEMPLATES);
		}
		return factTemplates;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getRules() {
		if (rules == null) {
			rules = new EObjectContainmentEList(RRule.class, this, RulemetamodelPackage.RMODULE__RULES);
		}
		return rules;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getRlists() {
		if (rlists == null) {
			rlists = new EObjectContainmentEList(RList.class, this, RulemetamodelPackage.RMODULE__RLISTS);
		}
		return rlists;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getFunctions() {
		if (functions == null) {
			functions = new EObjectContainmentEList(RFunction.class, this, RulemetamodelPackage.RMODULE__FUNCTIONS);
		}
		return functions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getOutputFilePath() {
		return outputFilePath;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOutputFilePath(String newOutputFilePath) {
		String oldOutputFilePath = outputFilePath;
		outputFilePath = newOutputFilePath;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RMODULE__OUTPUT_FILE_PATH, oldOutputFilePath, outputFilePath));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public void generate() {
		Module module = new Module();
		String result = module.generate(this);
		try {
			FileWriter writer = new FileWriter(outputFilePath, false);
			writer.write(result);
			writer.close();
			System.out.println("Rule file " + outputFilePath + " is successfully generated.");
		}
		catch (IOException ex) {
			System.out.println(ex.getMessage());
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case RulemetamodelPackage.RMODULE__FACT_TEMPLATES:
					return ((InternalEList)getFactTemplates()).basicRemove(otherEnd, msgs);
				case RulemetamodelPackage.RMODULE__RULES:
					return ((InternalEList)getRules()).basicRemove(otherEnd, msgs);
				case RulemetamodelPackage.RMODULE__RLISTS:
					return ((InternalEList)getRlists()).basicRemove(otherEnd, msgs);
				case RulemetamodelPackage.RMODULE__FUNCTIONS:
					return ((InternalEList)getFunctions()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RMODULE__FACT_TEMPLATES:
				return getFactTemplates();
			case RulemetamodelPackage.RMODULE__RULES:
				return getRules();
			case RulemetamodelPackage.RMODULE__RLISTS:
				return getRlists();
			case RulemetamodelPackage.RMODULE__FUNCTIONS:
				return getFunctions();
			case RulemetamodelPackage.RMODULE__OUTPUT_FILE_PATH:
				return getOutputFilePath();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RMODULE__FACT_TEMPLATES:
				getFactTemplates().clear();
				getFactTemplates().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RMODULE__RULES:
				getRules().clear();
				getRules().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RMODULE__RLISTS:
				getRlists().clear();
				getRlists().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RMODULE__FUNCTIONS:
				getFunctions().clear();
				getFunctions().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RMODULE__OUTPUT_FILE_PATH:
				setOutputFilePath((String)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RMODULE__FACT_TEMPLATES:
				getFactTemplates().clear();
				return;
			case RulemetamodelPackage.RMODULE__RULES:
				getRules().clear();
				return;
			case RulemetamodelPackage.RMODULE__RLISTS:
				getRlists().clear();
				return;
			case RulemetamodelPackage.RMODULE__FUNCTIONS:
				getFunctions().clear();
				return;
			case RulemetamodelPackage.RMODULE__OUTPUT_FILE_PATH:
				setOutputFilePath(OUTPUT_FILE_PATH_EDEFAULT);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RMODULE__FACT_TEMPLATES:
				return factTemplates != null && !factTemplates.isEmpty();
			case RulemetamodelPackage.RMODULE__RULES:
				return rules != null && !rules.isEmpty();
			case RulemetamodelPackage.RMODULE__RLISTS:
				return rlists != null && !rlists.isEmpty();
			case RulemetamodelPackage.RMODULE__FUNCTIONS:
				return functions != null && !functions.isEmpty();
			case RulemetamodelPackage.RMODULE__OUTPUT_FILE_PATH:
				return OUTPUT_FILE_PATH_EDEFAULT == null ? outputFilePath != null : !OUTPUT_FILE_PATH_EDEFAULT.equals(outputFilePath);
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (outputFilePath: ");
		result.append(outputFilePath);
		result.append(')');
		return result.toString();
	}

} //RModuleImpl
