/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.impl;

import com.example.rule.ecore.rulemetamodel.RFactTemplate;
import com.example.rule.ecore.rulemetamodel.RPattern;
import com.example.rule.ecore.rulemetamodel.RSlotMatchExp;
import com.example.rule.ecore.rulemetamodel.RulemetamodelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>RPattern</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RPatternImpl#getFactTemplate <em>Fact Template</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RPatternImpl#getSlotMatchExp <em>Slot Match Exp</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RPatternImpl extends RObjectImpl implements RPattern {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The cached value of the '{@link #getFactTemplate() <em>Fact Template</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactTemplate()
	 * @generated
	 * @ordered
	 */
	protected RFactTemplate factTemplate = null;

	/**
	 * The cached value of the '{@link #getSlotMatchExp() <em>Slot Match Exp</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSlotMatchExp()
	 * @generated
	 * @ordered
	 */
	protected EList slotMatchExp = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RPatternImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return RulemetamodelPackage.eINSTANCE.getRPattern();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RFactTemplate getFactTemplate() {
		if (factTemplate != null && factTemplate.eIsProxy()) {
			RFactTemplate oldFactTemplate = factTemplate;
			factTemplate = (RFactTemplate)eResolveProxy((InternalEObject)factTemplate);
			if (factTemplate != oldFactTemplate) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RulemetamodelPackage.RPATTERN__FACT_TEMPLATE, oldFactTemplate, factTemplate));
			}
		}
		return factTemplate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RFactTemplate basicGetFactTemplate() {
		return factTemplate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFactTemplate(RFactTemplate newFactTemplate) {
		RFactTemplate oldFactTemplate = factTemplate;
		factTemplate = newFactTemplate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RPATTERN__FACT_TEMPLATE, oldFactTemplate, factTemplate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getSlotMatchExp() {
		if (slotMatchExp == null) {
			slotMatchExp = new EObjectContainmentEList(RSlotMatchExp.class, this, RulemetamodelPackage.RPATTERN__SLOT_MATCH_EXP);
		}
		return slotMatchExp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case RulemetamodelPackage.RPATTERN__SLOT_MATCH_EXP:
					return ((InternalEList)getSlotMatchExp()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RPATTERN__FACT_TEMPLATE:
				if (resolve) return getFactTemplate();
				return basicGetFactTemplate();
			case RulemetamodelPackage.RPATTERN__SLOT_MATCH_EXP:
				return getSlotMatchExp();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RPATTERN__FACT_TEMPLATE:
				setFactTemplate((RFactTemplate)newValue);
				return;
			case RulemetamodelPackage.RPATTERN__SLOT_MATCH_EXP:
				getSlotMatchExp().clear();
				getSlotMatchExp().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RPATTERN__FACT_TEMPLATE:
				setFactTemplate((RFactTemplate)null);
				return;
			case RulemetamodelPackage.RPATTERN__SLOT_MATCH_EXP:
				getSlotMatchExp().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RPATTERN__FACT_TEMPLATE:
				return factTemplate != null;
			case RulemetamodelPackage.RPATTERN__SLOT_MATCH_EXP:
				return slotMatchExp != null && !slotMatchExp.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} //RPatternImpl
