/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.impl;

import com.example.rule.ecore.rulemetamodel.RCondElem;
import com.example.rule.ecore.rulemetamodel.RFunction;
import com.example.rule.ecore.rulemetamodel.RPattern;
import com.example.rule.ecore.rulemetamodel.RRule;
import com.example.rule.ecore.rulemetamodel.RRuleType;
import com.example.rule.ecore.rulemetamodel.RSymbol;
import com.example.rule.ecore.rulemetamodel.RulemetamodelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>RRule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl#getSalience <em>Salience</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl#getCondition <em>Condition</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl#getRuleName <em>Rule Name</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl#getActions <em>Actions</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl#getRuleType <em>Rule Type</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl#getCeMatchPattern <em>Ce Match Pattern</em>}</li>
 *   <li>{@link com.example.rule.ecore.rulemetamodel.impl.RRuleImpl#getDescription <em>Description</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RRuleImpl extends RObjectImpl implements RRule {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The default value of the '{@link #getSalience() <em>Salience</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSalience()
	 * @generated
	 * @ordered
	 */
	protected static final int SALIENCE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getSalience() <em>Salience</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSalience()
	 * @generated
	 * @ordered
	 */
	protected int salience = SALIENCE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCondition() <em>Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCondition()
	 * @generated
	 * @ordered
	 */
	protected RCondElem condition = null;

	/**
	 * The default value of the '{@link #getRuleName() <em>Rule Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRuleName()
	 * @generated
	 * @ordered
	 */
	protected static final RSymbol RULE_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getRuleName() <em>Rule Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRuleName()
	 * @generated
	 * @ordered
	 */
	protected RSymbol ruleName = RULE_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getActions() <em>Actions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActions()
	 * @generated
	 * @ordered
	 */
	protected EList actions = null;

	/**
	 * The default value of the '{@link #getRuleType() <em>Rule Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRuleType()
	 * @generated
	 * @ordered
	 */
	protected static final RRuleType RULE_TYPE_EDEFAULT = RRuleType.CONSTRAINT_LITERAL;

	/**
	 * The cached value of the '{@link #getRuleType() <em>Rule Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRuleType()
	 * @generated
	 * @ordered
	 */
	protected RRuleType ruleType = RULE_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCeMatchPattern() <em>Ce Match Pattern</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCeMatchPattern()
	 * @generated
	 * @ordered
	 */
	protected EList ceMatchPattern = null;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return RulemetamodelPackage.eINSTANCE.getRRule();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSalience() {
		return salience;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSalience(int newSalience) {
		int oldSalience = salience;
		salience = newSalience;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RRULE__SALIENCE, oldSalience, salience));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RCondElem getCondition() {
		return condition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCondition(RCondElem newCondition, NotificationChain msgs) {
		RCondElem oldCondition = condition;
		condition = newCondition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RRULE__CONDITION, oldCondition, newCondition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCondition(RCondElem newCondition) {
		if (newCondition != condition) {
			NotificationChain msgs = null;
			if (condition != null)
				msgs = ((InternalEObject)condition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - RulemetamodelPackage.RRULE__CONDITION, null, msgs);
			if (newCondition != null)
				msgs = ((InternalEObject)newCondition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - RulemetamodelPackage.RRULE__CONDITION, null, msgs);
			msgs = basicSetCondition(newCondition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RRULE__CONDITION, newCondition, newCondition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RSymbol getRuleName() {
		return ruleName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRuleName(RSymbol newRuleName) {
		RSymbol oldRuleName = ruleName;
		ruleName = newRuleName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RRULE__RULE_NAME, oldRuleName, ruleName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getActions() {
		if (actions == null) {
			actions = new EObjectResolvingEList(RFunction.class, this, RulemetamodelPackage.RRULE__ACTIONS);
		}
		return actions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RRuleType getRuleType() {
		return ruleType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRuleType(RRuleType newRuleType) {
		RRuleType oldRuleType = ruleType;
		ruleType = newRuleType == null ? RULE_TYPE_EDEFAULT : newRuleType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RRULE__RULE_TYPE, oldRuleType, ruleType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getCeMatchPattern() {
		if (ceMatchPattern == null) {
			ceMatchPattern = new EObjectContainmentEList(RPattern.class, this, RulemetamodelPackage.RRULE__CE_MATCH_PATTERN);
		}
		return ceMatchPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RulemetamodelPackage.RRULE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case RulemetamodelPackage.RRULE__CONDITION:
					return basicSetCondition(null, msgs);
				case RulemetamodelPackage.RRULE__CE_MATCH_PATTERN:
					return ((InternalEList)getCeMatchPattern()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RRULE__SALIENCE:
				return new Integer(getSalience());
			case RulemetamodelPackage.RRULE__CONDITION:
				return getCondition();
			case RulemetamodelPackage.RRULE__RULE_NAME:
				return getRuleName();
			case RulemetamodelPackage.RRULE__ACTIONS:
				return getActions();
			case RulemetamodelPackage.RRULE__RULE_TYPE:
				return getRuleType();
			case RulemetamodelPackage.RRULE__CE_MATCH_PATTERN:
				return getCeMatchPattern();
			case RulemetamodelPackage.RRULE__DESCRIPTION:
				return getDescription();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RRULE__SALIENCE:
				setSalience(((Integer)newValue).intValue());
				return;
			case RulemetamodelPackage.RRULE__CONDITION:
				setCondition((RCondElem)newValue);
				return;
			case RulemetamodelPackage.RRULE__RULE_NAME:
				setRuleName((RSymbol)newValue);
				return;
			case RulemetamodelPackage.RRULE__ACTIONS:
				getActions().clear();
				getActions().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RRULE__RULE_TYPE:
				setRuleType((RRuleType)newValue);
				return;
			case RulemetamodelPackage.RRULE__CE_MATCH_PATTERN:
				getCeMatchPattern().clear();
				getCeMatchPattern().addAll((Collection)newValue);
				return;
			case RulemetamodelPackage.RRULE__DESCRIPTION:
				setDescription((String)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RRULE__SALIENCE:
				setSalience(SALIENCE_EDEFAULT);
				return;
			case RulemetamodelPackage.RRULE__CONDITION:
				setCondition((RCondElem)null);
				return;
			case RulemetamodelPackage.RRULE__RULE_NAME:
				setRuleName(RULE_NAME_EDEFAULT);
				return;
			case RulemetamodelPackage.RRULE__ACTIONS:
				getActions().clear();
				return;
			case RulemetamodelPackage.RRULE__RULE_TYPE:
				setRuleType(RULE_TYPE_EDEFAULT);
				return;
			case RulemetamodelPackage.RRULE__CE_MATCH_PATTERN:
				getCeMatchPattern().clear();
				return;
			case RulemetamodelPackage.RRULE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case RulemetamodelPackage.RRULE__SALIENCE:
				return salience != SALIENCE_EDEFAULT;
			case RulemetamodelPackage.RRULE__CONDITION:
				return condition != null;
			case RulemetamodelPackage.RRULE__RULE_NAME:
				return RULE_NAME_EDEFAULT == null ? ruleName != null : !RULE_NAME_EDEFAULT.equals(ruleName);
			case RulemetamodelPackage.RRULE__ACTIONS:
				return actions != null && !actions.isEmpty();
			case RulemetamodelPackage.RRULE__RULE_TYPE:
				return ruleType != RULE_TYPE_EDEFAULT;
			case RulemetamodelPackage.RRULE__CE_MATCH_PATTERN:
				return ceMatchPattern != null && !ceMatchPattern.isEmpty();
			case RulemetamodelPackage.RRULE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (Salience: ");
		result.append(salience);
		result.append(", ruleName: ");
		result.append(ruleName);
		result.append(", ruleType: ");
		result.append(ruleType);
		result.append(", description: ");
		result.append(description);
		result.append(')');
		return result.toString();
	}

} //RRuleImpl
