/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.impl;

import com.example.rule.ecore.rulemetamodel.*;

import java.util.Map;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.impl.EFactoryImpl;
import com.example.rule.ecore.rulemetamodel.RDataType;
import com.example.rule.ecore.rulemetamodel.RFactAddress;
import com.example.rule.ecore.rulemetamodel.RFloat;
import com.example.rule.ecore.rulemetamodel.RInteger;
import com.example.rule.ecore.rulemetamodel.RMultiField;
import com.example.rule.ecore.rulemetamodel.RSymbol;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RulemetamodelFactoryImpl extends EFactoryImpl implements RulemetamodelFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * Creates and instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RulemetamodelFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case RulemetamodelPackage.RLIST: return createRList();
			case RulemetamodelPackage.RFACT_TEMPLATE: return createRFactTemplate();
			case RulemetamodelPackage.RRULE: return createRRule();
			case RulemetamodelPackage.RFACT_SLOT: return createRFactSlot();
			case RulemetamodelPackage.RPATTERN: return createRPattern();
			case RulemetamodelPackage.RSLOT_MATCH_EXP: return createRSlotMatchExp();
			case RulemetamodelPackage.RCOND_ELEM: return createRCondElem();
			case RulemetamodelPackage.RMODULE: return createRModule();
			case RulemetamodelPackage.ROBJECT: return createRObject();
			case RulemetamodelPackage.RFUNCTION: return createRFunction();
			case RulemetamodelPackage.RFACT: return createRFact();
			case RulemetamodelPackage.RSYMBOL_TO_DATA_TYPE_MAP_ENTRY: return (EObject)createRSymbolToDataTypeMapEntry();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case RulemetamodelPackage.RCOND_ELEM_ENUM: {
				RCondElemEnum result = RCondElemEnum.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case RulemetamodelPackage.RRULE_TYPE: {
				RRuleType result = RRuleType.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case RulemetamodelPackage.RFUNCTION_TYPE: {
				RFunctionType result = RFunctionType.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case RulemetamodelPackage.RSYMBOL:
				return createRSymbolFromString(eDataType, initialValue);
			case RulemetamodelPackage.RFACT_ADDRESS:
				return createRFactAddressFromString(eDataType, initialValue);
			case RulemetamodelPackage.RINTEGER:
				return createRIntegerFromString(eDataType, initialValue);
			case RulemetamodelPackage.RFLOAT:
				return createRFloatFromString(eDataType, initialValue);
			case RulemetamodelPackage.RDATA_TYPE:
				return createRDataTypeFromString(eDataType, initialValue);
			case RulemetamodelPackage.RMULTI_FIELD:
				return createRMultiFieldFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case RulemetamodelPackage.RCOND_ELEM_ENUM:
				return instanceValue == null ? null : instanceValue.toString();
			case RulemetamodelPackage.RRULE_TYPE:
				return instanceValue == null ? null : instanceValue.toString();
			case RulemetamodelPackage.RFUNCTION_TYPE:
				return instanceValue == null ? null : instanceValue.toString();
			case RulemetamodelPackage.RSYMBOL:
				return convertRSymbolToString(eDataType, instanceValue);
			case RulemetamodelPackage.RFACT_ADDRESS:
				return convertRFactAddressToString(eDataType, instanceValue);
			case RulemetamodelPackage.RINTEGER:
				return convertRIntegerToString(eDataType, instanceValue);
			case RulemetamodelPackage.RFLOAT:
				return convertRFloatToString(eDataType, instanceValue);
			case RulemetamodelPackage.RDATA_TYPE:
				return convertRDataTypeToString(eDataType, instanceValue);
			case RulemetamodelPackage.RMULTI_FIELD:
				return convertRMultiFieldToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RList createRList() {
		RListImpl rList = new RListImpl();
		return rList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RFactTemplate createRFactTemplate() {
		RFactTemplateImpl rFactTemplate = new RFactTemplateImpl();
		return rFactTemplate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RRule createRRule() {
		RRuleImpl rRule = new RRuleImpl();
		return rRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RFactSlot createRFactSlot() {
		RFactSlotImpl rFactSlot = new RFactSlotImpl();
		return rFactSlot;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RPattern createRPattern() {
		RPatternImpl rPattern = new RPatternImpl();
		return rPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RSlotMatchExp createRSlotMatchExp() {
		RSlotMatchExpImpl rSlotMatchExp = new RSlotMatchExpImpl();
		return rSlotMatchExp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RCondElem createRCondElem() {
		RCondElemImpl rCondElem = new RCondElemImpl();
		return rCondElem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RModule createRModule() {
		RModuleImpl rModule = new RModuleImpl();
		return rModule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RObject createRObject() {
		RObjectImpl rObject = new RObjectImpl();
		return rObject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RFunction createRFunction() {
		RFunctionImpl rFunction = new RFunctionImpl();
		return rFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RFact createRFact() {
		RFactImpl rFact = new RFactImpl();
		return rFact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Map.Entry createRSymbolToDataTypeMapEntry() {
		RSymbolToDataTypeMapEntryImpl rSymbolToDataTypeMapEntry = new RSymbolToDataTypeMapEntryImpl();
		return rSymbolToDataTypeMapEntry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public RSymbol createRSymbolFromString(EDataType eDataType, String initialValue) {
		return new RSymbol(initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRSymbolToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public RFactAddress createRFactAddressFromString(EDataType eDataType, String initialValue) {
		return new RFactAddress();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRFactAddressToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public RInteger createRIntegerFromString(EDataType eDataType, String initialValue) {
		return new RInteger();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRIntegerToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public RFloat createRFloatFromString(EDataType eDataType, String initialValue) {
		return new RFloat();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRFloatToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public RDataType createRDataTypeFromString(EDataType eDataType, String initialValue) {
		return new RDataType(initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRDataTypeToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	public RMultiField createRMultiFieldFromString(EDataType eDataType, String initialValue) {
		return new RMultiField(initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRMultiFieldToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RulemetamodelPackage getRulemetamodelPackage() {
		return (RulemetamodelPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static RulemetamodelPackage getPackage() {
		return RulemetamodelPackage.eINSTANCE;
	}

} //RulemetamodelFactoryImpl
