/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.provider;

import com.example.rule.ecore.rulemetamodel.util.RulemetamodelAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class RulemetamodelItemProviderAdapterFactory extends RulemetamodelAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection supportedTypes = new ArrayList();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RulemetamodelItemProviderAdapterFactory() {
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemPropertySource.class);
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RList} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RListItemProvider rListItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RList}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRListAdapter() {
		if (rListItemProvider == null) {
			rListItemProvider = new RListItemProvider(this);
		}

		return rListItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RFactTemplate} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RFactTemplateItemProvider rFactTemplateItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RFactTemplate}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRFactTemplateAdapter() {
		if (rFactTemplateItemProvider == null) {
			rFactTemplateItemProvider = new RFactTemplateItemProvider(this);
		}

		return rFactTemplateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RRule} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RRuleItemProvider rRuleItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RRule}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRRuleAdapter() {
		if (rRuleItemProvider == null) {
			rRuleItemProvider = new RRuleItemProvider(this);
		}

		return rRuleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RFactSlot} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RFactSlotItemProvider rFactSlotItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RFactSlot}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRFactSlotAdapter() {
		if (rFactSlotItemProvider == null) {
			rFactSlotItemProvider = new RFactSlotItemProvider(this);
		}

		return rFactSlotItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RPattern} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RPatternItemProvider rPatternItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RPattern}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRPatternAdapter() {
		if (rPatternItemProvider == null) {
			rPatternItemProvider = new RPatternItemProvider(this);
		}

		return rPatternItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RSlotMatchExp} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RSlotMatchExpItemProvider rSlotMatchExpItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RSlotMatchExp}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRSlotMatchExpAdapter() {
		if (rSlotMatchExpItemProvider == null) {
			rSlotMatchExpItemProvider = new RSlotMatchExpItemProvider(this);
		}

		return rSlotMatchExpItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RCondElem} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RCondElemItemProvider rCondElemItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RCondElem}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRCondElemAdapter() {
		if (rCondElemItemProvider == null) {
			rCondElemItemProvider = new RCondElemItemProvider(this);
		}

		return rCondElemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RModule} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RModuleItemProvider rModuleItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RModule}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRModuleAdapter() {
		if (rModuleItemProvider == null) {
			rModuleItemProvider = new RModuleItemProvider(this);
		}

		return rModuleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RObject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RObjectItemProvider rObjectItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RObject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRObjectAdapter() {
		if (rObjectItemProvider == null) {
			rObjectItemProvider = new RObjectItemProvider(this);
		}

		return rObjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RFunctionItemProvider rFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRFunctionAdapter() {
		if (rFunctionItemProvider == null) {
			rFunctionItemProvider = new RFunctionItemProvider(this);
		}

		return rFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link com.example.rule.ecore.rulemetamodel.RFact} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RFactItemProvider rFactItemProvider;

	/**
	 * This creates an adapter for a {@link com.example.rule.ecore.rulemetamodel.RFact}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRFactAdapter() {
		if (rFactItemProvider == null) {
			rFactItemProvider = new RFactItemProvider(this);
		}

		return rFactItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link java.util.Map.Entry} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RSymbolToDataTypeMapEntryItemProvider rSymbolToDataTypeMapEntryItemProvider;

	/**
	 * This creates an adapter for a {@link java.util.Map.Entry}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRSymbolToDataTypeMapEntryAdapter() {
		if (rSymbolToDataTypeMapEntryItemProvider == null) {
			rSymbolToDataTypeMapEntryItemProvider = new RSymbolToDataTypeMapEntryItemProvider(this);
		}

		return rSymbolToDataTypeMapEntryItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

}
