/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.util;

import com.example.rule.ecore.rulemetamodel.*;

import java.util.Map;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage
 * @generated
 */
public class RulemetamodelAdapterFactory extends AdapterFactoryImpl {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static RulemetamodelPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RulemetamodelAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = RulemetamodelPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RulemetamodelSwitch modelSwitch =
		new RulemetamodelSwitch() {
			public Object caseRList(RList object) {
				return createRListAdapter();
			}
			public Object caseRFactTemplate(RFactTemplate object) {
				return createRFactTemplateAdapter();
			}
			public Object caseRRule(RRule object) {
				return createRRuleAdapter();
			}
			public Object caseRFactSlot(RFactSlot object) {
				return createRFactSlotAdapter();
			}
			public Object caseRPattern(RPattern object) {
				return createRPatternAdapter();
			}
			public Object caseRSlotMatchExp(RSlotMatchExp object) {
				return createRSlotMatchExpAdapter();
			}
			public Object caseRCondElem(RCondElem object) {
				return createRCondElemAdapter();
			}
			public Object caseRModule(RModule object) {
				return createRModuleAdapter();
			}
			public Object caseRObject(RObject object) {
				return createRObjectAdapter();
			}
			public Object caseRFunction(RFunction object) {
				return createRFunctionAdapter();
			}
			public Object caseRFact(RFact object) {
				return createRFactAdapter();
			}
			public Object caseRSymbolToDataTypeMapEntry(Map.Entry object) {
				return createRSymbolToDataTypeMapEntryAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RList <em>RList</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RList
	 * @generated
	 */
	public Adapter createRListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RFactTemplate <em>RFact Template</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RFactTemplate
	 * @generated
	 */
	public Adapter createRFactTemplateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RRule <em>RRule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RRule
	 * @generated
	 */
	public Adapter createRRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RFactSlot <em>RFact Slot</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RFactSlot
	 * @generated
	 */
	public Adapter createRFactSlotAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RPattern <em>RPattern</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RPattern
	 * @generated
	 */
	public Adapter createRPatternAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RSlotMatchExp <em>RSlot Match Exp</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RSlotMatchExp
	 * @generated
	 */
	public Adapter createRSlotMatchExpAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RCondElem <em>RCond Elem</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RCondElem
	 * @generated
	 */
	public Adapter createRCondElemAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RModule <em>RModule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RModule
	 * @generated
	 */
	public Adapter createRModuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RObject <em>RObject</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RObject
	 * @generated
	 */
	public Adapter createRObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RFunction <em>RFunction</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RFunction
	 * @generated
	 */
	public Adapter createRFunctionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link com.example.rule.ecore.rulemetamodel.RFact <em>RFact</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see com.example.rule.ecore.rulemetamodel.RFact
	 * @generated
	 */
	public Adapter createRFactAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link java.util.Map.Entry <em>RSymbol To Data Type Map Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see java.util.Map.Entry
	 * @generated
	 */
	public Adapter createRSymbolToDataTypeMapEntryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //RulemetamodelAdapterFactory
