/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

package com.example.rule.ecore.rulemetamodel.util;

import com.example.rule.ecore.rulemetamodel.*;

import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.example.rule.ecore.rulemetamodel.RulemetamodelPackage
 * @generated
 */
public class RulemetamodelSwitch {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2004 Chaur G. Wu. All rights reserved.";

	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static RulemetamodelPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RulemetamodelSwitch() {
		if (modelPackage == null) {
			modelPackage = RulemetamodelPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case RulemetamodelPackage.RLIST: {
				RList rList = (RList)theEObject;
				Object result = caseRList(rList);
				if (result == null) result = caseRObject(rList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RFACT_TEMPLATE: {
				RFactTemplate rFactTemplate = (RFactTemplate)theEObject;
				Object result = caseRFactTemplate(rFactTemplate);
				if (result == null) result = caseRObject(rFactTemplate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RRULE: {
				RRule rRule = (RRule)theEObject;
				Object result = caseRRule(rRule);
				if (result == null) result = caseRObject(rRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RFACT_SLOT: {
				RFactSlot rFactSlot = (RFactSlot)theEObject;
				Object result = caseRFactSlot(rFactSlot);
				if (result == null) result = caseRObject(rFactSlot);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RPATTERN: {
				RPattern rPattern = (RPattern)theEObject;
				Object result = caseRPattern(rPattern);
				if (result == null) result = caseRObject(rPattern);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RSLOT_MATCH_EXP: {
				RSlotMatchExp rSlotMatchExp = (RSlotMatchExp)theEObject;
				Object result = caseRSlotMatchExp(rSlotMatchExp);
				if (result == null) result = caseRObject(rSlotMatchExp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RCOND_ELEM: {
				RCondElem rCondElem = (RCondElem)theEObject;
				Object result = caseRCondElem(rCondElem);
				if (result == null) result = caseRObject(rCondElem);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RMODULE: {
				RModule rModule = (RModule)theEObject;
				Object result = caseRModule(rModule);
				if (result == null) result = caseRObject(rModule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.ROBJECT: {
				RObject rObject = (RObject)theEObject;
				Object result = caseRObject(rObject);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RFUNCTION: {
				RFunction rFunction = (RFunction)theEObject;
				Object result = caseRFunction(rFunction);
				if (result == null) result = caseRObject(rFunction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RFACT: {
				RFact rFact = (RFact)theEObject;
				Object result = caseRFact(rFact);
				if (result == null) result = caseRObject(rFact);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RulemetamodelPackage.RSYMBOL_TO_DATA_TYPE_MAP_ENTRY: {
				Map.Entry rSymbolToDataTypeMapEntry = (Map.Entry)theEObject;
				Object result = caseRSymbolToDataTypeMapEntry(rSymbolToDataTypeMapEntry);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RList</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RList</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRList(RList object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RFact Template</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RFact Template</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRFactTemplate(RFactTemplate object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RRule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RRule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRRule(RRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RFact Slot</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RFact Slot</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRFactSlot(RFactSlot object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RPattern</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RPattern</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRPattern(RPattern object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RSlot Match Exp</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RSlot Match Exp</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRSlotMatchExp(RSlotMatchExp object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RCond Elem</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RCond Elem</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRCondElem(RCondElem object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RModule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RModule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRModule(RModule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRObject(RObject object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RFunction</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RFunction</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRFunction(RFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RFact</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RFact</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRFact(RFact object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RSymbol To Data Type Map Entry</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RSymbol To Data Type Map Entry</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRSymbolToDataTypeMapEntry(Map.Entry object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} //RulemetamodelSwitch
