package com.example.rule.ecore.templates;

import java.util.*;
import org.eclipse.emf.common.util.*;
import com.example.rule.ecore.rulemetamodel.*;

public class Module
{
  protected final String NL = System.getProperties().getProperty("line.separator");
  protected final String TEXT_1 = ";;;" + NL + "; Generate fact templates." + NL + ";;;";
  protected final String TEXT_2 = NL;
  protected final String TEXT_3 = NL;
  protected final String TEXT_4 = NL + NL + ";;;" + NL + "; Generate rules." + NL + ";;;";
  protected final String TEXT_5 = NL + NL + "(defrule ";
  protected final String TEXT_6 = NL + "\t=>";
  protected final String TEXT_7 = ")";
  protected final String TEXT_8 = "\t" + NL + "" + NL + "(reset)" + NL + "(run)" + NL + "(facts)    \t";

  public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    
/**
 * <copyright>
 *
 * Copyright (c) 2004 Chaur G. Wu. All rights reserved. 
 *
 * This program and the accompanying materials are made available 
 * under the terms of the Common Public License v1.0 which accompanies 
 * this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 *
 * </copyright>
 */

    RModule rModule = (RModule) argument;
    ModuleHelper moduleHelper = new ModuleHelper();
    stringBuffer.append(TEXT_1);
    for (Iterator fi = rModule.getFactTemplates().iterator();
  		fi.hasNext(); ) {
  	RFactTemplate factTemplate = (RFactTemplate) fi.next();
  	String factTemplateList = moduleHelper.factTemplateToListString(factTemplate);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(TEXT_3);
    stringBuffer.append( factTemplateList );
    }
    stringBuffer.append(TEXT_4);
    for (Iterator ri = rModule.getRules().iterator(); ri.hasNext(); ) {
  	  RRule rule = (RRule) ri.next();
  	  String matchedFactList = "";
  	  if (rule.getRuleType() == RRuleType.CONSTRAINT_LITERAL) {
  	  	  matchedFactList = moduleHelper.getMatchedFactListString(rule);
  	  }
  	  RCondElem ce = rule.getCondition();
  	  String ceList = moduleHelper.ceToListString(ce, rule.getRuleType());
  	  EList patterns = rule.getCeMatchPattern();
  	  EList actions = rule.getActions();

    stringBuffer.append(TEXT_5);
    stringBuffer.append( rule.getRuleName().toListString() );
        stringBuffer.append(matchedFactList);
	  stringBuffer.append(ceList);
	  for (Iterator pi = patterns.iterator(); pi.hasNext(); ) {
		RPattern pattern = (RPattern) pi.next();
		String patternList = moduleHelper.patternToListString(pattern, rule.getRuleType());
		stringBuffer.append("\n" + patternList);
	  }

    stringBuffer.append(TEXT_6);
    	  for (Iterator ai = actions.iterator(); ai.hasNext(); ) {
		RFunction action = (RFunction) ai.next();
		String actionList = moduleHelper.actionToListString(action);
		stringBuffer.append("\n  " + actionList);
	  }

    stringBuffer.append(TEXT_7);
    }
    stringBuffer.append(TEXT_8);
    return stringBuffer.toString();
  }
}
